/*
@Functions
*/
#ifndef H_MUSEFUNC
#define H_MUSEFUNC

#if XVT_CC == XVT_CC_THINK
#define _H_MUSEDEF
#endif

#if 0
#ifndef INCL_XVTH
#include "xvt.h"
#endif
#endif
#include "noxvt.h"

#ifndef H_MUSEDEF
#include "musedef.h"
#endif

#ifndef H_MACHINE
#include "machine.h"
#endif

#if 0
#if XVT_OS != XVT_OS_SUNOS
#define context_sensitive_help(a, b) xvt_help();
#endif
#endif


/***************************************************************
@    add_color_bias()
****************************************************************
Adds PAL_OFFSET from the raster bitmap.
*/
#if XVT_CC_PROTO
ERRSTATUS add_color_bias(GHANDLE bitmap);
#else
ERRSTATUS add_color_bias();
#endif
/*
Description:
*/

/***************************************************************
@    available_construct()
****************************************************************
Constructs the available structure
*/
#if XVT_CC_PROTO
ERRSTATUS available_construct(AVAILABLE** pointer);
#else
ERRSTATUS available_construct();
#endif
/*
Description:
Builds and sets the argument to a structure of
type AVAILABLE.  This structure contains lists
of data products, buttons, windows, units, etc.
that are available to the user and programmer.
*/

/***************************************************************
@    available_destruct()
****************************************************************
Destructs the available structure
*/
#if XVT_CC_PROTO
ERRSTATUS available_destruct(AVAILABLE** pointer);
#else
ERRSTATUS available_destruct();
#endif
/*
Description:

*/

/***************************************************************
@    available_structure()
****************************************************************
Gets pointer to the available structure
*/
#if XVT_CC_PROTO
ERRSTATUS available_structure(AVAILABLE** avail);
#else
ERRSTATUS available_structure();
#endif
/*
Description:
Sets the pointer argument to the available structure.
*/

/***************************************************************
@    basemap_construct()
****************************************************************
Constructs the basemap
*/
#if XVT_CC_PROTO
ERRSTATUS basemap_construct(
    FILE *file,
    BASEMAP **basemap);
#else
ERRSTATUS basemap_construct();
#endif
/*
Description:
Constructs a basemap object.  IF file is not NULL
the basemap is read in from the file.
/***************************************************************
@    basemap_destruct()
****************************************************************
Destroys the basemap structure
*/
#if XVT_CC_PROTO
ERRSTATUS basemap_destruct(
    FILE *file,
    BOOLEAN destruct,
    BASEMAP **basemap);
#else
ERRSTATUS basemap_destruct();
#endif
/*
Description:
If file is not NULL the basemap is written to the file.
If destruct is TRUE the basemap memory is released.
*/

/***************************************************************
@    basemap_new_bitmap()
****************************************************************
Get a new bit_map raster
*/
#if XVT_CC_PROTO
ERRSTATUS basemap_new_bitmap(long width,
                             long height,
                             long bits_per_pixel,
                             RASTER **bit_map);
#else
ERRSTATUS basemap_new_bitmap();
#endif
/*
Description:
If the bit_map already exists, it is deleted.
A new bit_map object of type RASTER is created according to
the specified dimensions.
*/

/***************************************************************
@    basemap_match_geometry()
****************************************************************
Sets up the map geometry to match the basemap geometry
*/
#if XVT_CC_PROTO
ERRSTATUS basemap_match_geometry(BASEMAP *basemap, MGM *mgm);
#else
ERRSTATUS basemap_match_geometry();
#endif
/*
Description:
The map geometry object mgm is adjusted to the basemap's
projection and geographic extent, so that vector overlays,
and the cursor readout will be correct.


/***************************************************************
@    basemap_setup()
****************************************************************
Sets up the basemap
*/
#if XVT_CC_PROTO
ERRSTATUS basemap_setup(
	BASEMAP *basemap,
	MGM *mgm);
#else
ERRSTATUS basemap_setup();
#endif
/*
Description:
Sets up the basemap by calling any needed
product constructors and setup functions.

*/

/***************************************************************
@    big_fread()
****************************************************************
Reads in an arbitrarily large chunk of data
*/

#if XVT_CC_PROTO
ERRSTATUS big_fread(
    FILE *file,
    GHANDLE handle,
    unsigned long length_in_bytes,
    NUM_TYPE num_type,
    DATA_TYPE data_type);
#else
ERRSTATUS big_fread();
#endif

/*
Description:
Big_fread allows reading of blocks of data larger than
64K bytes on all systems, including DOS.
*/

/***************************************************************
@    big_fwrite()
****************************************************************
Writes an arbitrarily large chunk of data
*/

#if XVT_CC_PROTO
ERRSTATUS big_fwrite(
    FILE *file,
    GHANDLE handle,
    unsigned long length_in_bytes,
    NUM_TYPE num_type,
    DATA_TYPE data_type);
#else
ERRSTATUS big_fwrite();
#endif

/*
Description:
Big_fwrite allows writing of blocks of data larger than
64K bytes on all systems, including DOS.
*/

/***************************************************************
@    bit_to_geo()
****************************************************************
Converts a bit map coordinate to geographic
*/
#if XVT_CC_PROTO
ERRSTATUS bit_to_geo(MGM *mgm,
	GFLOAT bitx, GFLOAT bity,
	GFLOAT *londd, GFLOAT *latdd);
#else
ERRSTATUS bit_to_geo();
#endif
/*
Description:
Using the map geometry in the first argument,
the bitx and bity are inverse map projected
to decimal degrees (last 2 args).  Bitmap coordinates
are the indices into the raster basemap files and images.
*/

/***************************************************************
@    bit_to_win()
****************************************************************
Converts a bitmap coordinate to a window coordinate.
*/
#if XVT_CC_PROTO
ERRSTATUS bit_to_win(WINDOW xvt_win,
	GFLOAT bitx, GFLOAT bity,
	GFLOAT *winx, GFLOAT *winy);
#else
ERRSTATUS bit_to_win();
#endif
/*
Description:
Bitmap coordinates are indices into the raster objects.
Their origin is at the lower left.
Window coordinates are returned in mouse event records.
Their origin is at the upper left.
*/

/***************************************************************
@    buttons_get_available_list()
****************************************************************
Reverse Bonne map projection
*/
#if XVT_CC_PROTO
ERRSTATUS buttons_get_available_list(BUTTONS_LIST **p);
#else
ERRSTATUS buttons_get_available_list();
#endif
/*
Description:

*/
#if 0
/***************************************************************
@    context_sensitive_help()
****************************************************************
Invokes the MUSE context sensitive help
*/
#if XVT_CC_PROTO
void context_sensitive_help(
    FILE_SPEC *help_file_spec,
    char *help_topic);
#else
void context_sensitive_help();
#endif
#endif

/*
Description:
This extension of the XVT help facility (provided by XVT as
\xvt\source\vhelp.c) is to be called when the user pushes
the HELP button in a dialog.  The first argument is the
XVT FILE_SPEC of the help file.  The second argument
is the specific help topic that relates to dialog that
contains the help button.  The help_topic given as the second
argument must contain no leading or trailing spaces.
*/

/***************************************************************
@    cot()
****************************************************************
cotangent function
*/
#if XVT_CC_PROTO
double cot(double a);
#else
double cot();
#endif
/*
Description:

*/

/***************************************************************
@    convert_double()
****************************************************************
Converts among double machine formats
*/
#if XVT_CC_PROTO
void convert_double(
    unsigned char *the_double,
    long type);
#else
void convert_double();
#endif
/*
Description:
This function converts the_double number between different local
double number formats.

The type argument determines the type of conversion performed.
The following are supported

  TYPE  CONVERSION

    1 = IEEE to VAX
    2 = VAX to IEEE
    3 = IEEE to SUN
    4 = SUN to IEEE
    5 = SUN to VAX
    6 = VAX to SUN
    7 = IEEE to MAC
    8 = MAC to IEEE

*/

/***************************************************************
@    cubm_from_cubf()
****************************************************************
Cubic meters from cubic feet
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_from_cubf(
  double *meter, double feet);
#else
ERRSTATUS cubm_from_cubf();
#endif
/*
Description:

*/

/***************************************************************
@    cubm_from_cubkm()
****************************************************************
Cubic meters from cubic kilometers
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_from_cubkm(
  double *meter, double kmeter);
#else
ERRSTATUS cubm_from_cubkm();
#endif
/*
Description:

*/

/***************************************************************
@    cubm_from_cubm()
****************************************************************
Cubic meters from cubic meters
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_from_cubm(
  double *meter1, double meter2);
#else
ERRSTATUS cubm_from_cubm();
#endif
/*
Description:

*/

/***************************************************************
@    cubm_from_cubnm()
****************************************************************
Cubic meters from cubic nautical miles
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_from_cubnm(
  double *meter, double nmile);
#else
ERRSTATUS cubm_from_cubnm();
#endif
/*
Description:

*/

/***************************************************************
@    cubm_from_cubsm()
****************************************************************
Cubic meters from cubic statute miles
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_from_cubsm(
  double *meter, double stmile);
#else
ERRSTATUS cubm_from_cubsm();
#endif
/*
Description:

*/

/***************************************************************
@    cubm_to_cubf()
****************************************************************
Cubic meters to cubic feet
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_to_cubf(
  double meter, double *feet);
#else
ERRSTATUS cubm_to_cubf();
#endif
/*
Description:

*/

/***************************************************************
@    cubm_to_cubkm()
****************************************************************
Cubic meters to cubic kilometers
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_to_cubkm(
  double meter, double *kmeter);
#else
ERRSTATUS cubm_to_cubkm();
#endif
/*
Description:

*/

/***************************************************************
@    cubm_to_cubm()
****************************************************************
Cubic meters to cubic meters
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_to_cubm(
  double meter1, double *meter2);
#else
ERRSTATUS cubm_to_cubm();
#endif
/*
Description:

*/

/***************************************************************
@    cubm_to_cubnm()
****************************************************************
Cubic meters to cubic nautical miles
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_to_cubnm(
  double meter, double *nmile);
#else
ERRSTATUS cubm_to_cubnm();
#endif
/*
Description:

*/

/***************************************************************
@    cubm_to_cubsm()
****************************************************************
Cubic meters to cubic statute miles
*/
#if XVT_CC_PROTO
ERRSTATUS cubm_to_cubsm(
  double meter, double *stmile);
#else
ERRSTATUS cubm_to_cubsm();
#endif
/*
Description:

*/

/***************************************************************
@    defaults_get_cur()
****************************************************************
Get pointer to map defaults structure
*/
#if XVT_CC_PROTO
ERRSTATUS defaults_get_cur(
  DEFAULTS **defaults);
#else
ERRSTATUS defaults_get_cur();
#endif
/*
Description:
Sets your DEFAULTS pointer pointing to the defaults
structure which you may examine or modify.
*/

/***************************************************************
@    defaults_get_available()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS defaults_get_available(DEFAULTS **p);
#else
ERRSTATUS defaults_get_available();
#endif
/*
Description:

*/

/***************************************************************
@    do_close()
****************************************************************
Close a map document
*/
#if XVT_CC_PROTO
ERRSTATUS do_close(WINDOW win, BOOLEAN save, BOOLEAN destroy,
    BOOLEAN ask);
#else
ERRSTATUS do_close();
#endif
/*
Description:
Closes the map document associated with the argument win.
If save is TRUE, the the user will be given a chance to save it.
If destroy is TRUE the map document will be deleted from memory.
If ask is true the user can cancel the save.
*/

/***************************************************************
@    do_open()
****************************************************************
Opens a map document
*/
#if XVT_CC_PROTO
ERRSTATUS do_open(FILE_SPEC *file);
#else
ERRSTATUS do_open();
#endif
/*
Description:
The map document is created and, if the file argument is
not NULL, loaded from the specified file.
*/

/***************************************************************
@    do_print_map()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS do_print_map(void);
#else
ERRSTATUS do_print_map();
#endif
/*
Description:
*/

/***************************************************************
@    dbdb5_get_area()
****************************************************************
Gets a raster of DBDB5 data
*/
#if XVT_CC_PROTO
ERRSTATUS dbdb5_get_area(RASTER *raster, FILE_SPEC *file_spec);
#else
ERRSTATUS dbdb5_get_area();
#endif
/*
Description:

*/

/***************************************************************
@    dbdb5_metadata_construct()
****************************************************************
Construct a pointer to a text buffer containing documentation
on DBDB5
*/
#if XVT_CC_PROTO
ERRSTATUS dbdb5_metadata_construct(BASEMAP *basemap, TEXT *text , FILE_SPEC *file_spec);
#else
ERRSTATUS dbdb5_metadata_construct();
#endif
/*
Description:

*/

/***************************************************************
@    dbdb5_metadata_destruct()
****************************************************************
Destroy the text buffer created by dbdb5_metadata_construct()
*/
#if XVT_CC_PROTO
ERRSTATUS dbdb5_metadata_destruct(TEXT *text);
#else
ERRSTATUS dbdb5_metadata_destruct();
#endif
/*
Description:

*/

/***************************************************************
@    defaults_construct()
****************************************************************
Destroy the text buffer created by dbdb5_metadata_construct()
*/
#if XVT_CC_PROTO
ERRSTATUS defaults_construct(FILE *file, DEFAULTS **pointer);
#else
ERRSTATUS defaults_construct();
#endif
/*
Description:

*/

/***************************************************************
@    defaults_destruct()
****************************************************************
Destroy the text buffer created by dbdb5_metadata_construct()
*/
#if XVT_CC_PROTO
ERRSTATUS defaults_destruct
(
    FILE*        file, 
    BOOLEAN      destruct,
    DEFAULTS**   defaults
);
#else
ERRSTATUS defaults_destruct();
#endif
/*
Description:

*/

/***************************************************************
@    decode_basemap()
****************************************************************
Convert basemap structure to local binary
*/
#if XVT_CC_PROTO
ERRSTATUS decode_basemap(
    unsigned char *buffer,
    BASEMAP *basemap);
#else
ERRSTATUS decode_basemap();
#endif
/*
Description:
The basemap structure information in the
character buffer (binary portable Intel format)
is placed into the basemap structure in local
binary.  Used by the constructor functions while loading in
a map document.
*/

/***************************************************************
@    decode_grat()
****************************************************************
Convert grat structure to local binary
*/
#if XVT_CC_PROTO
ERRSTATUS decode_grat(unsigned char *buffer,GRAT_DATA *grat, long version);
#else
ERRSTATUS decode_grat();
#endif
/*
Description:
The grat structure information in the
character buffer (binary portable Intel format)
is placed into the grat structure in local
binary.  Used by the constructor functions while loading in
a map document.
*/

/***************************************************************
@    decode_mapdoc()
****************************************************************
Convert map_doc structure to local binary
*/
#if XVT_CC_PROTO
ERRSTATUS decode_mapdoc(
    unsigned char *buffer,
    MAP_DOC *map_doc);
#else
ERRSTATUS decode_mapdoc();
#endif
/*
Description:
The map_doc structure information in the
character buffer (binary portable Intel format)
is placed into the map_doc structure in local
binary.  Used by the constructor functions while loading in
a map document.
*/

/***************************************************************
@    decode_mgm()
****************************************************************
Convert mgm structure to local binary
*/
#if XVT_CC_PROTO
ERRSTATUS decode_mgm(
    unsigned char *buffer,
    MGM *mgm);
#else
ERRSTATUS decode_mgm();
#endif
/*
Description:
The mgm structure information in the
character buffer (binary portable Intel format)
is placed into the mgm structure in local
binary.  Used by the constructor functions while loading in
a map document.
*/

/***************************************************************
@    decode_palette()
****************************************************************
Convert palette structure to local binary
*/
#if XVT_CC_PROTO
ERRSTATUS decode_palette(
    unsigned char *buffer,
    PALETTE *palette);
#else
ERRSTATUS decode_palette();
#endif
/*
Description:
The palette structure information in the
character buffer (binary portable Intel format)
is placed into the palette structure in local
binary.  Used by the constructor functions while loading in
a map document.
*/

/***************************************************************
@    decode_lut()
****************************************************************
Convert lut structure to local binary
*/
#if XVT_CC_PROTO
ERRSTATUS decode_lut(
    unsigned char *record,
    LUT *lut);
#else
ERRSTATUS decode_lut();
#endif
/*
Description:
The lut structure information in the
character buffer (binary portable Intel format)
is placed into the lut structure in local
binary.  Used by the constructor functions while loading in
a map document.
*/

/***************************************************************
@    decode_products()
****************************************************************
Convert products structure to local binary
*/
#if XVT_CC_PROTO
ERRSTATUS decode_products(
    unsigned char *buffer,
    PRODUCTS *products);
#else
ERRSTATUS decode_products();
#endif
/*
Description:
The products structure information in the
character buffer (binary portable Intel format)
is placed into the products structure in local
binary.  Used by the constructor functions while loading in
a map document.
*/

/***************************************************************
@    decode_raster_hdr()
****************************************************************
Convert raster_hdr structure to local binary
*/
#if XVT_CC_PROTO
ERRSTATUS decode_raster_hdr(
    unsigned char *buffer,
    RASTER *raster);
#else
ERRSTATUS decode_raster_hdr();
#endif
/*
Description:
The raster structure information in the
character buffer (binary portable Intel format)
is placed into the raster structure in local
binary.  Used by the constructor functions while loading in
a map document.
*/

/***************************************************************
@    decode_units()
****************************************************************
Convert units structure to local binary
*/
#if XVT_CC_PROTO
ERRSTATUS decode_units(
    unsigned char *buffer,
    UNITS *units);
#else
ERRSTATUS decode_units();
#endif
/*
Description:
The units structure information in the
character buffer (binary portable Intel format)
is placed into the units structure in local
binary.  Used by the constructor functions while loading in
a map document.
*/

/***************************************************************
@    encode_basemap()
****************************************************************
Convert basemap structure to external form
*/
#if XVT_CC_PROTO
ERRSTATUS encode_basemap(
    unsigned char *buffer,
    BASEMAP *basemap);
#else
ERRSTATUS encode_basemap();
#endif
/*
Description:
The basemap structure is converted to the
external binary portable (Intel) format.
Used by the destructor functions while preparing
to store a map document.
*/

/***************************************************************
@    encode_grat()
****************************************************************
Convert grat structure to external form
*/
#if XVT_CC_PROTO
ERRSTATUS encode_grat(unsigned char *buffer, GRAT_DATA *grat);
#else
ERRSTATUS encode_grat();
#endif
/*
Description:
The grat structure is converted to the
external binary portable (Intel) format.
Used by the destructor functions while preparing
to store a map document.
*/
/***************************************************************
@    encode_lut()
****************************************************************
Convert lut structure external form
*/
#if XVT_CC_PROTO
ERRSTATUS encode_lut(
    unsigned char *buffer,
    LUT *lut);
#else
ERRSTATUS encode_lut();
#endif
/*
Description:
The lut structure is converted to the
external binary portable (Intel) format.
Used by the destructor functions while preparing
to store a map document.
*/

/***************************************************************
@    encode_mapdoc()
****************************************************************
Convert map_doc structure external form
*/
#if XVT_CC_PROTO
ERRSTATUS encode_mapdoc(
    unsigned char *buffer,
    MAP_DOC *map_doc);
#else
ERRSTATUS encode_mapdoc();
#endif
/*
Description:
The map_doc structure is converted to the
external binary portable (Intel) format.
Used by the destructor functions while preparing
to store a map document.
*/

/***************************************************************
@    encode_mgm()
****************************************************************
Convert mgm structure external form
*/
#if XVT_CC_PROTO
ERRSTATUS encode_mgm(
    unsigned char *buffer,
    MGM *mgm);
#else
ERRSTATUS encode_mgm();
#endif
/*
Description:
The mgm structure is converted to the
external binary portable (Intel) format.
Used by the destructor functions while preparing
to store a map document.
*/

/***************************************************************
@    encode_palette()
****************************************************************
Convert palette structure external form
*/
#if XVT_CC_PROTO
ERRSTATUS encode_palette(
    unsigned char *buffer,
    PALETTE *palette);
#else
ERRSTATUS encode_palette();
#endif
/*
Description:
The palette structure is converted to the
external binary portable (Intel) format.
Used by the destructor functions while preparing
to store a map document.
*/

/***************************************************************
@    encode_products()
****************************************************************
Convert products structure external form
*/
#if XVT_CC_PROTO
ERRSTATUS encode_products(
    unsigned char *buffer,
    PRODUCTS *products);
#else
ERRSTATUS encode_products();
#endif
/*
Description:
The products structure is converted to the
external binary portable (Intel) format.
Used by the destructor functions while preparing
to store a map document.
*/

/***************************************************************
@    encode_raster_hdr()
****************************************************************
Convert raster_hdr structure external form
*/
#if XVT_CC_PROTO
ERRSTATUS encode_raster_hdr(
    unsigned char *buffer,
    RASTER *raster);
#else
ERRSTATUS encode_raster_hdr();
#endif
/*
Description:
The raster structure is converted to the
external binary portable (Intel) format.
Used by the destructor functions while preparing
to store a map document.
*/

/***************************************************************
@    encode_units()
****************************************************************
Convert units structure external form
*/
#if XVT_CC_PROTO
ERRSTATUS encode_units(
    unsigned char *buffer,
    UNITS *units);
#else
ERRSTATUS encode_units();
#endif
/*
Description:
The units structure is converted to the
external binary portable (Intel) format.
Used by the destructor functions while preparing
to store a map document.
*/

/***************************************************************
@    file_spec_to_string()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS file_spec_to_string
(
    FILE_SPEC*  file_spec,
    char*       string
);
#else
ERRSTATUS file_spec_to_string();
#endif
/*
Description:

*/

/***************************************************************
@    geo_to_bit()
****************************************************************
Convert the geographic coordinate to a bit map or raster coord.
*/
#if XVT_CC_PROTO
ERRSTATUS geo_to_bit(MGM *mgm,
	GFLOAT londd, GFLOAT latdd,
	GFLOAT *bitx, GFLOAT *bity);
#else
ERRSTATUS geo_to_bit();
#endif
/*
Description:

*/

/***************************************************************
@    geo_to_user_str()
****************************************************************
Convert the geographic coordinate to user formatted string
*/
#if XVT_CC_PROTO
ERRSTATUS geo_to_user_str(short geo_units, POINT_DD *value, char *output);
#else
ERRSTATUS geo_to_user_str();
#endif
#if XVT_CC_PROTO
ERRSTATUS user_str_to_geo(short geo_units, POINT_DD *value, char *output);
#else
ERRSTATUS user_str_to_geo();
#endif
/*
Description:

*/

/***************************************************************
@    geo_to_win()
****************************************************************
Convert the geographic coordinate to a window coordinate
*/
#if XVT_CC_PROTO
ERRSTATUS geo_to_win(MGM *mgm, WINDOW xvt_win,
	GFLOAT londd, GFLOAT latdd,
	GFLOAT *winx, GFLOAT *winy);
#else
ERRSTATUS geo_to_win();
#endif
/*
Description:

*/


/***************************************************************
@    geo_to_view()
****************************************************************
Convert the geographic coordinate to a view coordinate
*/
#if XVT_CC_PROTO
ERRSTATUS geo_to_view(MGM *mgm, WINDOW xvt_win,
	GFLOAT londd, GFLOAT latdd,
	GFLOAT *viewx, GFLOAT *viewy);
#else
ERRSTATUS geo_to_view();
#endif
/*
Description:
The input geographic coordinate is in decimal degrees.
The output is a view coordinate which is a window
coordinate which may have been zoomed and scrolled.
*/


/***********************************************************
@       get_user_pt()
************************************************************
Invoke a dialog box that allows entry of a map point in user units
*/
#if XVT_CC_PROTO
ERRSTATUS get_user_pt
(
    MAP_POINT  *map_point,
    GEOGRAPHIC  user_units
);
#else
ERRSTATUS get_user_pt();
#endif


/***************************************************************
@    grat()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS grat(short count, MGM *mgm);
#else
ERRSTATUS grat();
#endif
/*
Description:

*/

/***************************************************************
@    grat_construct()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS grat_construct(FILE *file, GRAT_DATA **pointer, long version);
#else
ERRSTATUS grat_construct();
#endif
/*
Description:
*/

/***************************************************************
@    grat_destruct()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS grat_destruct(FILE *file, BOOLEAN destruct, GRAT_DATA **grat);
#else
ERRSTATUS grat_destruct();
#endif
/*
Description:

*/


/***************************************************************
@    hsv2rgb()
****************************************************************
Invoke a user interface dialog or window
*/
#if XVT_CC_PROTO
ERRSTATUS hsv2rgb(GFLOAT hue, GFLOAT sat, GFLOAT val,
     GFLOAT *r, GFLOAT *g, GFLOAT *b);
#else
ERRSTATUS hsv2rgb();
#endif
/*
Description:

*/

/***************************************************************
@    lut2pal()
****************************************************************
Generates a palette from a look-up-table
*/

#if XVT_CC_PROTO
ERRSTATUS lut2pal(
    LUT *lut,
    COLOR_PREF color_pref,
    PALETTE *pal);
#else
ERRSTATUS lut2pal();
#endif

/*
Description:
The color information contained in the lut in
the form of hue, saturation, and value is used
to generate the palette.
*/

/***************************************************************
@    lut_construct()
****************************************************************
Create a look-up-table.
*/
#if XVT_CC_PROTO
ERRSTATUS lut_construct (
    FILE *file,
    PALETTE *pal,
    LUT **lut);
#else
ERRSTATUS lut_construct ();
#endif
/*
Description:
If the file argument is not NULL, the look_up_table will be
read in from the file.  Otherwise a default lut will
be created. Lut's define the relationship between data values
and the colors used to display them on the map.
*/

/***************************************************************
@    lut_destruct()
****************************************************************
Frees up the lut memory.
*/
#if XVT_CC_PROTO
ERRSTATUS lut_destruct(
    FILE *file,
    BOOLEAN destruct,
    LUT **lut);
#else
ERRSTATUS lut_destruct();
#endif
/*
Description:
If the file argument is not NULL the lut is written into the
file using fwrite.  If the destruct argument is true the
lut is removed from memory.
*/
/***************************************************************
@    lut_gen()
****************************************************************

*/
#if XVT_CC_PROTO
ERRSTATUS lut_gen(
    LUT_DESC *lut_desc);
#else
ERRSTATUS lut_gen();
#endif
/*

*/


/***************************************************************
@    lamber_config()
****************************************************************
Configure the Lambert Conformal Conic projection
*/
#if XVT_CC_PROTO
ERRSTATUS lamber_config(MGM *mgm);
#else
ERRSTATUS lamber_config();
#endif
/*
Description:
Performs the necessary calculations
to fit the requested geo-area into the
image bitmap.

*/

/***************************************************************
@    lamber_map()
****************************************************************
Forward Lambert Conformal Conic projection
*/
#if XVT_CC_PROTO
ERRSTATUS lamber_map(
    MGM *mgm,
    GFLOAT londd,
    GFLOAT latdd,
    GFLOAT *x,
    GFLOAT *y);
#else
ERRSTATUS lamber_map();
#endif
/*
Description:
Converts the geo-coordinate into
a map image coordinate.

*/

/***************************************************************
@    lamber_unmap()
****************************************************************
Reverse Lambert Conformal Conic projection

*/
#if XVT_CC_PROTO
ERRSTATUS lamber_unmap(
    MGM *mgm,
    GFLOAT *londd,
    GFLOAT *latdd,
    GFLOAT x,
    GFLOAT y);
#else
ERRSTATUS lamber_unmap();
#endif
/*
Description:
Converts the map image coordinate
into a geo-coordinate.

*/

/***************************************************************
@    linear_config()
****************************************************************
Configure the linear map projction
*/
#if XVT_CC_PROTO
ERRSTATUS linear_config(MGM *mgm);
#else
ERRSTATUS linear_config();
#endif
/*
Description:
Performs the necessary calculations
to fit the requested geo-area into the
image bitmap.

*/

/***************************************************************
@    linear_map()
****************************************************************
Forward linear projection
*/
#if XVT_CC_PROTO
ERRSTATUS linear_map(
	MGM *mgm,
	GFLOAT londd,
	GFLOAT latdd,
	GFLOAT *x,
	GFLOAT *y);
#else
ERRSTATUS linear_map();
#endif
/*
Description:
Converts the geo-coordinate into
a map image coordinate.

*/

/***************************************************************
@    linear_unmap()
****************************************************************
Reverse linear projection
*/
#if XVT_CC_PROTO
ERRSTATUS linear_unmap(
	MGM *mgm,
	GFLOAT *londd,
    GFLOAT *latdd,
    GFLOAT x,
    GFLOAT y);
#else
ERRSTATUS linear_unmap();
#endif
/*
Description:
Converts the map image coordinate
into a geo-coordinate.

*/


/***************************************************************
@    lut_lookup()
****************************************************************
Look up a data value in a look-up-table
*/
#if XVT_CC_PROTO
ERRSTATUS lut_lookup(
    LUT *lut,
    GFLOAT data,
    GFLOAT delta,
    GFLOAT shade_threshold,
    GFLOAT precision,
    USHORT *index);     /* long *color */
#else
ERRSTATUS lut_lookup();
#endif
/*
Description:
Looks up the data value and delta
in the lut and returns the color index.

*/

/***************************************************************
@    map()
****************************************************************
Map the geographic coordinate into a bit map and PHIGS coord
*/
#if XVT_CC_PROTO
ERRSTATUS map(
    MGM *mgm,
    GFLOAT londd,
    GFLOAT latdd,
    GFLOAT *x,
    GFLOAT *y);
#else
ERRSTATUS map();
#endif
/*
Description:
Converts the geo-coordinate into
a map image coordinate.

*/

/***************************************************************
@    map_doc_construct()
****************************************************************
Create a map document
*/
#if XVT_CC_PROTO
ERRSTATUS map_doc_construct(
    FILE *file,
    MAP_DOC **pointer);
#else
ERRSTATUS map_doc_construct();
#endif
/*
Description:
Calls the constructors for the sub-structures to allocate
a new  map document.  If the file argument is not NULL,
the map document is read in from the file.
*/

/***************************************************************
@    map_doc_get_cur()
****************************************************************
Get the map document pointer for the current map
*/
#if XVT_CC_PROTO
ERRSTATUS map_doc_get_cur(
    MAP_DOC **pointer);
#else
ERRSTATUS map_doc_get_cur();
#endif
/*
Description:
This function sets your pointer to the address
of the map document that is displayed in the
front map window.
*/

/***************************************************************
@    map_doc_destruct()
****************************************************************
Destroy the map document
*/
#if XVT_CC_PROTO
ERRSTATUS map_doc_destruct(
    FILE *file,
    BOOLEAN destruct,
    MAP_DOC **map_doc,
    MUSEBYTE_ORDER *bo);
#else
ERRSTATUS map_doc_destruct();
#endif
/*
Description:
If the file argument is not NULL, the map document is written
to the file. If the destruct argument is TRUE, the map document
is removed from memory.

*/


/***************************************************************
@    mercat_config()
****************************************************************
Configure Mercator projection
*/
#if XVT_CC_PROTO
ERRSTATUS mercat_config(MGM *mgm);
#else
ERRSTATUS mercat_config();
#endif
/*
Description:
Performs the necessary calculations
to fit the requested geo-area into the
image bitmap.

*/

/***************************************************************
@    mercat_map()
****************************************************************
Forward Mercator projection
*/
#if XVT_CC_PROTO
ERRSTATUS mercat_map(
    MGM *mgm,
    GFLOAT londd,
    GFLOAT latdd,
    GFLOAT *x,
    GFLOAT *y);
#else
ERRSTATUS mercat_map();
#endif
/*
Description:
Converts the geo-coordinate into
a map image coordinate.

*/

/***************************************************************
@    mercat_unmap()
****************************************************************
Reverse Mercator projection
*/
#if XVT_CC_PROTO
ERRSTATUS mercat_unmap(
    MGM *mgm,
    GFLOAT *londd,
    GFLOAT *latdd,
    GFLOAT x,
    GFLOAT y);
#else
ERRSTATUS mercat_unmap();
#endif
/*
Description:
Converts the map image coordinate
into a geo-coordinate.

*/

/***************************************************************
@    mgm_adjust()
****************************************************************
Adjust the map geometry
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_adjust(
	MGM *mgm);
#else
ERRSTATUS mgm_adjust();
#endif
/*
Description:
Adjusts mgm parameters according to
the CONFIG_PREF.

*/

/***************************************************************
@    mgm_config()
****************************************************************
Configure an MGM object.
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_config(MGM *mgm);
#else
ERRSTATUS mgm_config();
#endif
/*
Description:

*/

/***************************************************************
@    mgm_construct()
****************************************************************
Allocates space for a map MGM object.
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_construct(
    FILE *file,
    MGM **mgm ,
    DEFAULTS *defaults);
#else
ERRSTATUS mgm_construct();
#endif
/*
Description:

*/

/***************************************************************
@    mgm_defaults()
****************************************************************
Assigns default parameters for the map geometry.
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_defaults(
    MGM *mgm , DEFAULTS *defaults);
#else
ERRSTATUS mgm_defaults();
#endif
/*
Description:

*/

/***************************************************************
@    mgm_destruct()
****************************************************************
Destroys the MGM object.
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_destruct(
    FILE *file,
    BOOLEAN destruct,
    MGM **mgm);
#else
ERRSTATUS mgm_destruct();
#endif
/*
Description:

*/

/***************************************************************
@    mgm_fit()
****************************************************************
Fit the geographic area to the bit map image
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_fit(
    MGM *mgm);
#else
ERRSTATUS mgm_fit();
#endif
/*
Description:
Performs the necessary calculations
to fit the requested geo-area into an
arbitrary output coordinate range.

*/

/***************************************************************
@    map_it()
****************************************************************
Performs map projection, both forward and reverse
*/
#if XVT_CC_PROTO
ERRSTATUS map_it(MGM* mgm, PROJ_DIR forward_or_reverse,
    GFLOAT *londd, GFLOAT *latdd,
    GFLOAT *phigs_x, GFLOAT *phigs_y);
#else
ERRSTATUS map_it();
#endif
/*
Description:
The map geometry object mgm is used project in the direction
given by forward_or_reverse.  Note that forward_or_reverse
determine whether the GP is computed based on the xy or vice
versa, so bad things will happen with no error messages
if this function is misused.
*/

/***************************************************************
@    mgm_is_ok()
****************************************************************
Check the MGM structure for DMA legal usage
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_is_ok(MGM* mgm, char *what_is_wrong);
#else
ERRSTATUS mgm_is_ok();
#endif
/*
Description:
If the mgm object is valid according to the DMA
rules of map projection usage, STAT_SUCCESS is
returned.  If the mgm object is not legal, then
STAT_INV_PROJ is returned and the string argument
what_is_wrong contains a description of the problem.
*/

/***************************************************************
@    mgm_get_available_list()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_get_available_list(MGM_LIST** p);
#else
ERRSTATUS mgm_get_available_list();
#endif
/*
Description:

*/

/***************************************************************
@    mgm_setup()
****************************************************************
Setup the map geometry
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_set
(
    int         proj,
    PROJECTION* projection
);
#else
ERRSTATUS mgm_set();
#endif
/*
Description:

*/

/***************************************************************
@    mgm_setup()
****************************************************************
Setup the map geometry
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_setup(
    MGM *mgm);
#else
ERRSTATUS mgm_setup();
#endif
/*
Description:
Configures the map geometry object
according to the mode specified by
MGM->CONFIG_PREF

*/

/***************************************************************
@    mgm_subclass()
****************************************************************
Sub-class the map geometry object to a particular projection
*/
#if XVT_CC_PROTO
ERRSTATUS mgm_subclass(
    MGM *mgm);
#else
ERRSTATUS mgm_subclass();
#endif
/*
Description:
Assigns the generic map, unmap, and
mgm_config pointers to a specific
projection.

*/

/***************************************************************
@    pacify()
****************************************************************
Inform user of program status
*/

#if XVT_CC_PROTO
BOOLEAN pacify(
    char *message,
    short percent_complete);
#else
BOOLEAN pacify();
#endif

/*
Description:
The message and percent_complete are displayed
in the status window.  The status window has a cancel button
Pacify returns TRUE if the user has pressed this cancel button.
In this case you should terminate the operation and call
pacify with a "Ready" message and a NULL percent_complete.
*/

/***************************************************************
@    palette_construct()
****************************************************************
Construct a color palette.
*/
#if XVT_CC_PROTO
ERRSTATUS palette_construct (
    FILE *file,
    PALETTE **palette);
#else
ERRSTATUS palette_construct ();
#endif
/*
Description:
If the file argument is not NULL the palette is loaded from
the file.  Otherwise, a default palette is created.
*/

/***************************************************************
@    palette_destruct()
****************************************************************
Destroy the color palette
*/
#if XVT_CC_PROTO
ERRSTATUS palette_destruct(
    FILE *file,
    BOOLEAN destruct,
    PALETTE **palette);
#else
ERRSTATUS palette_destruct();
#endif
/*
Description:
If the file argument is not NULL, the palette is read from
the file, otherwise a default palette is created.
*/

/***************************************************************
@    palette_rgbcube_construct()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS palette_rgbcube_construct(PALETTE** pointer);
#else
ERRSTATUS palette_rgbcube_construct();
#endif
/*
Description:
*/

/***************************************************************
@    pal_nearest_color()
****************************************************************
Gets a palette color from an RGB color
*/

#if XVT_CC_PROTO
ERRSTATUS pal_nearest_color(
    PALETTE *palette,
    RGB rgb,
    USHORT *color_index);
#else
ERRSTATUS pal_nearest_color();
#endif

/*
Description:
Maps the input RGB color into the palette.  The method used
depends on the palette type.

*/

/***************************************************************
@    pal_rgb_bins_construct()
****************************************************************
Construct a palette of RGB bins
*/

#if XVT_CC_PROTO
ERRSTATUS pal_gen(
    PALETTE *palette);
#else
ERRSTATUS pal_gen();
#endif

/*
Description:
Constructs a palette as a 3D matrix of color with red, green,
and blue on the 3 axes.  The palette structure must have been
initialized with the desired PAL_TYPE and the bin counts for
red, green, and blue. The total number of
bins must not exceed 256.
*/

/***************************************************************
@    pdmstodd()
****************************************************************
*/
#if XVT_CC_PROTO
void pdmstodd
(
    float   pdms,
    float*  dd
);
#else
void pdmstodd();
#endif

/*
Description:
*/

/***************************************************************
@    print_map()
****************************************************************
*/
#if XVT_CC_PROTO
BOOLEAN print_map(long page_num);
#else
BOOLEAN print_map();
#endif

/*
Description:
*/

/***************************************************************
@    products_construct()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS products_construct(FILE* file, PRODUCTS** pointer,MUSEBYTE_ORDER *bo);
#else
ERRSTATUS products_construct();
#endif

/*
Description:
*/

/***************************************************************
@    products_destruct()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS products_destruct
(
    FILE*       file,
    BOOLEAN     destruct,
    PRODUCTS**  products,
    MUSEBYTE_ORDER* bo
);
#else
ERRSTATUS products_destruct();
#endif

/*
Description:
*/

/***************************************************************
@    products_get_available_list()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS products_get_available_list(PRODUCTS_LIST **p);
#else
ERRSTATUS products_get_available_list();
#endif

/*
Description:
*/

/***************************************************************
@    put_rect()
****************************************************************
*/
#if XVT_CC_PROTO
void put_rect(WINDOW win, BUTTON* button);
#else
void put_rect();
#endif

/*
Description:
*/

/***************************************************************
@    raster_construct()
****************************************************************
Construct a RASTER object
*/
#if XVT_CC_PROTO
ERRSTATUS raster_construct(
    FILE *file,
    RASTER **pointer);
#else
/*ERRSTATUS raster_construct();*/
#endif
/*
Description:
If the file argument is not NULL, the raster is read in
from the file, otherwise a default raster is created.
*/

/***************************************************************
@    raster_construct_data()
****************************************************************
Allocates memory for the raster data
*/
#if XVT_CC_PROTO
ERRSTATUS raster_construct_data(
    RASTER *raster);
#else
ERRSTATUS raster_construct_data();
#endif
/*
Description:
Once the raster has been created (using raster-construct()) and
the width, height, and bits_per_pixel initialized, this function
may be called to allocate global heap space for the data.
*/

/***************************************************************
@    raster_copy()
****************************************************************
Copy an object of type RASTER
*/
#if XVT_CC_PROTO
ERRSTATUS raster_copy(
    RASTER *in,
    RASTER *out);
#else
ERRSTATUS raster_copy();
#endif
/*
Description:

*/

/***************************************************************
@    raster_data_to_indirect()
****************************************************************
Convert a raster containing non-image data into a color image
*/
#if XVT_CC_PROTO
ERRSTATUS raster_data_to_indirect(
    RASTER *in,
    RASTER *out,
    RENDER_INFO *render_info,
    LUT *default_lut,
    PALETTE *default_palette);
#else
ERRSTATUS raster_data_to_indirect();
#endif
/*
Description:
Pseudocoloring using a look-up-table is used to produce the
image raster.

*/

/***************************************************************
@    raster_destruct()
****************************************************************
Destroy the object of type RASTER
*/
#if XVT_CC_PROTO
ERRSTATUS raster_destruct(
    FILE *file,
    BOOLEAN destruct,
    RASTER **pointer);
#else
ERRSTATUS raster_destruct();
#endif
/*
Description:
If the file argument is not NULL, the raster is written to the
file.  If destruct is TRUE the object of type RASTER is removed
from memory.

*/

/***************************************************************
@    raster_draw()
****************************************************************
Draw the (drawable) raster to the map window
*/
#if XVT_CC_PROTO
ERRSTATUS raster_draw(
    RASTER *raster, WINDOW map_window);
#else
ERRSTATUS raster_draw();
#endif
/*
Description:
The raster must be in drawable form.  To be drawable, a raster
must contain data of type COLOR_INDIRECT.
Rraster_xform() is used to
convert the various data rasters to a drawable form.

*/

/***************************************************************
@    raster_indirect_to_indirect()
****************************************************************
Convert the indirect raster to a new palette
*/
#if XVT_CC_PROTO
ERRSTATUS raster_indirect_to_indirect(
    RASTER *in,
    RASTER *out,
    PALETTE *new_palette);
#else
ERRSTATUS raster_indirect_to_indirect();
#endif
/*
Description:

*/

/***************************************************************
@    raster_indirect_to_rgb()
****************************************************************
Convert the indirect raster containing an RGB raster
*/
#if XVT_CC_PROTO
ERRSTATUS raster_indirect_to_rgb(
    RASTER *in,
    RASTER *out);
#else
ERRSTATUS raster_indirect_to_rgb();
#endif
/*
Description:

*/

/***************************************************************
@    raster_rgb_to_indirect()
****************************************************************
Convert the raster containing an RGB image to a color map image
*/
#if XVT_CC_PROTO
ERRSTATUS raster_rgb_to_indirect(
    RASTER *in,
    RASTER *out,
    PALETTE *default_palette);
#else
ERRSTATUS raster_rgb_to_indirect();
#endif
/*
Description:

*/

/***************************************************************
@    raster_setup()
****************************************************************
Setup the object of type RASTER
*/
#if XVT_CC_PROTO
ERRSTATUS raster_setup(
    BASEMAP *basemap,
    MGM *mgm);
#else
ERRSTATUS raster_setup();
#endif
/*
Description:

*/

/***************************************************************
@    raster_xform()
****************************************************************
Convert a raster to a displayable image form
*/
#if XVT_CC_PROTO
ERRSTATUS raster_xform
(
    RASTER*         in,
    RASTER*         out,
    RENDER_INFO*    render_info,
    LUT *           default_lut,
    PALETTE *       default_palette
);
#else
ERRSTATUS raster_xform();
#endif
/*
Description:
Rasters containing non-image data are rendered.  RGB images
rasters are converted to color map rasters.
*/

/***************************************************************
@    rgb2uvw()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS rgb2uvw(long r, long g, long b, long* u, long* v, long* w);
#else
ERRSTATUS rgb2uvw();
#endif
/*
Description:
*/

/***************************************************************
@    remove_color_bias()
****************************************************************
Removes PAL_OFFSET from the raster bitmap.
*/
#if XVT_CC_PROTO
ERRSTATUS remove_color_bias(GHANDLE bitmap);
#else
ERRSTATUS remove_color_bias();
#endif
/*
Description:
*/

/***************************************************************
@     scale_to_user_str
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS scale_to_user_str
(
    UNITS*  units,
    GFLOAT  scale_reciprocal,
    char*   output
);
#else
ERRSTATUS scale_to_user_str();
#endif
/*
Description:

*/
/***************************************************************
@     set_menu
****************************************************************
Sets up menu bar for PC.
*/
#if XVT_CC_PROTO
void set_menu
(
    WINDOW win
);
#else
void set_menu();
#endif


void
#if XVT_CC_PROTO
set_wait(short status);
#else
set_wait();
#endif

/*
Description:

*/

/***************************************************************
@    sqm_from_sqf()
****************************************************************
Square meters from square feet
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_from_sqf(
  GFLOAT *sqm, GFLOAT sqf);
#else
ERRSTATUS sqm_from_sqf();
#endif
/*
Description:

*/

/***************************************************************
@    sqm_from_sqkm()
****************************************************************
Square meters from square kilometers
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_from_sqkm(
  GFLOAT *sqm, GFLOAT sqkm);
#else
ERRSTATUS sqm_from_sqkm();
#endif
/*
Description:

*/

/***************************************************************
@    sqm_from_sqm()
****************************************************************
Square meters from square meters
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_from_sqm(
  GFLOAT *sqm1, GFLOAT sqm2);
#else
ERRSTATUS sqm_from_sqm();
#endif
/*
Description:

*/

/***************************************************************
@    sqm_from_sqnm()
****************************************************************
Square meters from square nautical miles
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_from_sqnm(
  GFLOAT *sqm, GFLOAT sqnm);
#else
ERRSTATUS sqm_from_sqnm();
#endif
/*
Description:

*/

/***************************************************************
@    sqm_from_sqsm()
****************************************************************
Square meters from square statue miles
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_from_sqsm(
  GFLOAT *sqm, GFLOAT sqnm);
#else
ERRSTATUS sqm_from_sqsm();
#endif
/*
Description:

*/

/***************************************************************
@    sqm_to_sqf()
****************************************************************
Square meters to square feet
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_to_sqf(
  GFLOAT sqm, GFLOAT *sqf);
#else
ERRSTATUS sqm_to_sqf();
#endif
/*
Description:

*/

/***************************************************************
@    sqm_to_sqkm()
****************************************************************
Square meters to square kilometers
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_to_sqkm(
  GFLOAT sqm, GFLOAT *sqkm);
#else
ERRSTATUS sqm_to_sqkm();
#endif
/*
Description:

*/

/***************************************************************
@    sqm_to_sqm()
****************************************************************
Square meters to square meters
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_to_sqm(
  GFLOAT sqm1, GFLOAT *sqm2);
#else
ERRSTATUS sqm_to_sqm();
#endif
/*
Description:

*/

/***************************************************************
@    sqm_to_sqnm()
****************************************************************
Square meters to square nautical miles
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_to_sqnm(
  GFLOAT sqm, GFLOAT *sqnm);
#else
ERRSTATUS sqm_to_sqnm();
#endif
/*
Description:

*/

/***************************************************************
@    sqm_to_sqsm()
****************************************************************
Square meters to square statute miles
*/
#if XVT_CC_PROTO
ERRSTATUS sqm_to_sqsm(
  GFLOAT sqm, GFLOAT *sqsm);
#else
ERRSTATUS sqm_to_sqsm();
#endif
/*
Description:

*/

/***************************************************************
@    stereo_config()
****************************************************************
Configure the stereographic map projection
*/
#if XVT_CC_PROTO
ERRSTATUS stereo_config(
    MGM *mgm);
#else
ERRSTATUS stereo_config();
#endif
/*
Description:
Performs the necessary calculations
to fit the requested geo-area into the
image bitmap.

*/

/***************************************************************
@    string_to_file_spec()
****************************************************************
*/
#if XVT_CC_PROTO
ERRSTATUS string_to_file_spec(FILE_SPEC *file_spec, char *string);
#else
ERRSTATUS string_to_file_spec();
#endif
/*
Description:
*/

/***************************************************************
@    transm_config()
****************************************************************
Configure transverse Mercator projection
*/
#if XVT_CC_PROTO
ERRSTATUS transm_config(
    MGM *mgm);
#else
ERRSTATUS transm_config();
#endif
/*
Description:
Performs the necessary calculations
to fit the requested geo-area into the
image bitmap.

*/

/***************************************************************
@    transm_map()
****************************************************************
Forward transverse Mercator projection
*/
#if XVT_CC_PROTO
ERRSTATUS transm_map(
    MGM *mgm,
    GFLOAT londd,
    GFLOAT latdd,
    GFLOAT *x,
    GFLOAT *y);
#else
ERRSTATUS transm_map();
#endif
/*
Description:
Converts the geo-coordinate into
a map image coordinate.

*/

/***************************************************************
@    transm_unmap()
****************************************************************
Reverse transverse Mercator projection
*/
#if XVT_CC_PROTO
ERRSTATUS transm_unmap(
    MGM *mgm,
    GFLOAT *londd,
    GFLOAT *latdd,
    GFLOAT x,
    GFLOAT y);
#else
ERRSTATUS transm_unmap();
#endif
/*
Description:
Converts the map image coordinate
into a geo-coordinate.

*/

/***************************************************************
@    units_construct()
****************************************************************
Construct the units object
*/
#if XVT_CC_PROTO
ERRSTATUS units_construct(
    FILE *file,
    UNITS **pointer);
#else
ERRSTATUS units_construct();
#endif
/*
Description:
The units object contains a list of the user selected map
units.
*/

/***************************************************************
@    units_destruct()
****************************************************************
Destroy the object of type UNITS
*/
#if XVT_CC_PROTO
ERRSTATUS units_destruct(
    FILE *file,
    BOOLEAN destruct,
    UNITS **pointer);
#else
ERRSTATUS units_destruct();
#endif
/*
Description:

*/

/***************************************************************
@    units_get_available_list()
****************************************************************
Get pointer to the list of available map units
*/
#if XVT_CC_PROTO
ERRSTATUS units_get_available_list(UNITS_LIST **p);
#else
ERRSTATUS units_get_available_list();
#endif
/*
Description:

*/

/***************************************************************
@    unmap()
****************************************************************

*/
#if XVT_CC_PROTO
ERRSTATUS unmap(
    MGM *mgm,
    GFLOAT *londd,
    GFLOAT *latdd,
    GFLOAT x,
    GFLOAT y);
#else
ERRSTATUS unmap();
#endif
/*
Description:
Converts the display coordinate to
the equivalent geographic coordinate.

*/

/***************************************************************
@    update()
****************************************************************
Bring the current map window up to date
*/
#if XVT_CC_PROTO
ERRSTATUS update(MAP_DOC *mapdoc);
#else
ERRSTATUS update();
#endif
/*
Description:
*/

/***************************************************************
@    update_map()
****************************************************************
*/
#if XVT_CC_PROTO
void   update_map(WINDOW win);
#else
void   update_map();
#endif
/*
Description:
*/

/***************************************************************
@    update_wait()
****************************************************************
Sets windows and cursors during a map update.
*/
#if XVT_CC_PROTO
ERRSTATUS update_wait(BOOLEAN on);
#else
ERRSTATUS update_wait();
#endif
/*
Description:

*/

/***************************************************************
@    uvw2rgb()
****************************************************************
Sets windows and cursors during a map update.
*/
#if XVT_CC_PROTO
ERRSTATUS uvw2rgb(long u, long v, long w, long *r, long *g, long *b);
#else
ERRSTATUS uvw2rgb();
#endif
/*
Description:

*/
/***************************************************************
@    view_to_bit()
****************************************************************
Convert a view(mouse) coord to a bit-map coord
*/
#if XVT_CC_PROTO
ERRSTATUS view_to_bit(
    WINDOW xvt_win,  /* view contains zoom and scrool info*/
    GFLOAT viewx, /* the mouse coordinate */
    GFLOAT viewy,
    GFLOAT *bitx, /* the bit_map coord */
    GFLOAT *bity);
#else
ERRSTATUS view_to_bit();
#endif
/*
Description:

*/

/***************************************************************
@    view_to_geo()
****************************************************************
Convert the view coordinate to a geographic coordinate
*/
#if XVT_CC_PROTO
ERRSTATUS view_to_geo(MGM *mgm, WINDOW xvt_win,
	GFLOAT viewx, GFLOAT viewy,
	GFLOAT *londd, GFLOAT *latdd);
#else
ERRSTATUS view_to_geo();
#endif
/*
Description:
The input is a view coordinate which is a window
coordinate which may have been zoomed and scrolled.
The output geographic coordinate is in decimal degrees.
*/


/***************************************************************
@    win_to_bit()
****************************************************************
Convert the window coordinate to a bit map coord
*/
#if XVT_CC_PROTO
ERRSTATUS win_to_bit(WINDOW xvt_win,
	GFLOAT winx, GFLOAT winy,
	GFLOAT *bitx, GFLOAT *bity);
#else
ERRSTATUS win_to_bit();
#endif
/*
Description:

*/

/***************************************************************
@    win_to_geo()
****************************************************************
Convert the window coordinated to a geographic coord
*/
#if XVT_CC_PROTO
ERRSTATUS win_to_geo(MGM *mgm, WINDOW xvt_win,
	GFLOAT winx, GFLOAT winy,
	GFLOAT *londd, GFLOAT *latdd);
#else
ERRSTATUS win_to_geo();
#endif
/*
Description:

*/

/***************************************************************
@    windows_get_available_list()
****************************************************************
Convert the window coordinated to a geographic coord
*/
#if XVT_CC_PROTO
ERRSTATUS windows_get_available_list(WINDOWS** p);
#else
ERRSTATUS windows_get_available_list();
#endif
/*
Description:

*/


#if XVT_CC_PROTO
   void lowercase (char*);
   void eol (char*, char*);
   long machine_byte_order (void);
#else
   void lowercase ();
   void eol ();
   long machine_byte_order ();
#endif

#endif /* #ifndef H_MUSEFUNC */
