/*
 * Copyright 1993-1995 Cartoactive Systems, Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef mapclasses_h
#define mapclasses_h

#include <OverlayUnidraw/ovclasses.h>

/* 
 * Unique MapUnidraw class identifiers.
 */

#define MAPABOUT_CMD       9201
#define MAPSHOW_CMD        9202
#define MAPSHOWALL_CMD     9203
#define MAPHIDE_CMD        9204
#define GEOPOINT_CMD       9205
#define POINT_CMD          9206
#define MAPPROJECTION_CMD  9207
#define MAPLIB_CMD         9208
#define MAPCOV_CMD         9209
#define MAPFCLASS_CMD      9210
#define MAPSELECTION_CMD   9211
#define CONTOUR_CMD        9212
#define MAPEXPORT_CMD      9213
#define MAPOPEN_CMD        9214
#define MAPIMPORT_CMD      9215
#define MAPUPDATEMENUS_CMD 9216

#define MAPINSPECT_TOOL    9220
#define CAMERAPOS_TOOL     9221
#define CAMERAPATH_TOOL    9222
#define GEOLOC_TOOL        9223

#define MAPFEATURE_COMP    9250
#define MAPFCLASS_COMP     9251
#define MAPCOV_COMP        9252
#define MAPLIB_COMP        9253
#define MAPDB_COMP         9254
#define MAP_IDRAW_COMP	   9255
#define AREAFEATURE_COMP   9256
#define LINEFEATURE_COMP   9257
#define POINTFEATURE_COMP  9258
#define MAPLAYER_COMP      9259
#define TEXTFEATURE_COMP   9260
#define GEOPOINT_COMP      9261
#define MAP_ROUTE_COMP     9262

#define PROJECTION_VAR     9280
#define SCALE_VAR          9281
#define MAPDB_VAR          9282
#define MAPLIB_VAR         9283
#define MAPCOV_VAR         9284
#define MAPFCLASS_VAR      9285
#define MAPSELECTION_VAR   9286

#define RAWMAP_VIEW        2071

/* Composite ids associating subjects with their views */

#define MAPFEATURE_VIEW    Combine(MAPFEATURE_COMP, COMPONENT_VIEW)
#define MAPFCLASS_VIEW     Combine(MAPFCLASS_COMP, COMPONENT_VIEW)
#define MAPCOV_VIEW        Combine(MAPCOV_COMP, COMPONENT_VIEW)
#define MAPLIB_VIEW        Combine(MAPLIB_COMP, COMPONENT_VIEW)
#define MAPDB_VIEW         Combine(MAPDB_COMP, COMPONENT_VIEW)
#define MAP_IDRAW_VIEW     Combine(MAP_IDRAW_COMP, COMPONENT_VIEW)
#define AREAFEATURE_VIEW   Combine(AREAFEATURE_COMP, COMPONENT_VIEW)
#define LINEFEATURE_VIEW   Combine(LINEFEATURE_COMP, COMPONENT_VIEW)
#define MAPLAYER_VIEW      Combine(MAPLAYER_COMP, COMPONENT_VIEW)
#define POINTFEATURE_VIEW  Combine(POINTFEATURE_COMP, COMPONENT_VIEW)
#define TEXTFEATURE_VIEW   Combine(TEXTFEATURE_COMP, COMPONENT_VIEW)
#define GEOPOINT_VIEW      Combine(GEOPOINT_COMP, COMPONENT_VIEW)
#define MAP_ROUTE_VIEW     Combine(MAP_ROUTE_COMP, COMPONENT_VIEW)

#define MAPFEATURE_SCRIPT  Combine(MAPFEATURE_COMP, SCRIPT_VIEW)
#define MAPFCLASS_SCRIPT   Combine(MAPFCLASS_COMP, SCRIPT_VIEW)
#define MAPCOV_SCRIPT      Combine(MAPCOV_COMP, SCRIPT_VIEW)
#define MAPLIB_SCRIPT      Combine(MAPLIB_COMP, SCRIPT_VIEW)
#define MAPDB_SCRIPT       Combine(MAPDB_COMP, SCRIPT_VIEW)
#define MAP_IDRAW_SCRIPT   Combine(MAP_IDRAW_COMP, SCRIPT_VIEW)
#define AREAFEATURE_SCRIPT Combine(AREAFEATURE_COMP, SCRIPT_VIEW)
#define LINEFEATURE_SCRIPT Combine(LINEFEATURE_COMP, SCRIPT_VIEW)
#define MAPLAYER_SCRIPT    Combine(MAPLAYER_COMP, SCRIPT_VIEW)
#define POINTFEATURE_SCRIPT Combine(POINTFEATURE_COMP, SCRIPT_VIEW)
#define TEXTFEATURE_SCRIPT Combine(TEXTFEATURE_COMP, SCRIPT_VIEW)
#define GEOPOINT_SCRIPT    Combine(GEOPOINT_COMP, SCRIPT_VIEW)
#define MAP_ROUTE_SCRIPT   Combine(MAP_ROUTE_COMP, SCRIPT_VIEW)
#define MAP_ROUTE_PS       Combine(MAP_ROUTE_COMP, POSTSCRIPT_VIEW)

#define MAPFEATURE_PS      Combine(MAPFEATURE_COMP, POSTSCRIPT_VIEW)
#define MAPFCLASS_PS       Combine(MAPFCLASS_COMP, POSTSCRIPT_VIEW)
#define MAPCOV_PS          Combine(MAPCOV_COMP, POSTSCRIPT_VIEW)
#define MAPLIB_PS          Combine(MAPLIB_COMP, POSTSCRIPT_VIEW)
#define MAPDB_PS           Combine(MAPDB_COMP, POSTSCRIPT_VIEW)
#define MAP_IDRAW_PS       Combine(MAP_IDRAW_COMP, POSTSCRIPT_VIEW)
#define AREAFEATURE_PS     Combine(AREAFEATURE_COMP, POSTSCRIPT_VIEW)
#define LINEFEATURE_PS     Combine(LINEFEATURE_COMP, POSTSCRIPT_VIEW)
#define MAPLAYER_PS        Combine(MAPLAYER_COMP, POSTSCRIPT_VIEW)
#define POINTFEATURE_PS     Combine(POINTFEATURE_COMP, POSTSCRIPT_VIEW)
#define TEXTFEATURE_PS     Combine(TEXTFEATURE_COMP, POSTSCRIPT_VIEW)
#define GEOPOINT_PS        Combine(GEOPOINT_COMP, POSTSCRIPT_VIEW)

#define MAPFEATURE_RAW     Combine(MAPFEATURE_COMP, RAWMAP_VIEW)
#define MAPFCLASS_RAW      Combine(MAPFCLASS_COMP, RAWMAP_VIEW)

#endif
